function test_annif(j1,m1,j2,m2)

  implicit none

  ! Variables en argument
  integer, intent(in) :: j1,m1,j2,m2
  ! Declaration de la fonction
  logical :: test_annif

  ! Instructions
  test_annif = .false.
  if ( j1==j2 .and. m1==m2 ) then
    test_annif = .true.
  end if

end function test_annif

!-----------------------------------------------
subroutine calcul_nb_lignes(nom_fichier,nlignes)

  implicit none

  ! Variables en argument
  character (len=15), intent(in) :: nom_fichier
  integer, intent(out) :: nlignes
  ! Variables locales
  integer :: ierr    ! =0 si ok, /=0 sinon

  ! Instructions
  open(10,file=nom_fichier,iostat=ierr)
  nlignes = 0
  do while (ierr==0)
    read(10,*,iostat=ierr)
    if (ierr==0) then
       nlignes = nlignes + 1
    end if
  end do
  close(10)

end subroutine calcul_nb_lignes


!------------------------------------------------------
subroutine qui_annif(nom_fichier,n_amis,date_du_jour,p)

  implicit none

  ! Definition de la structure
  type personne
    integer :: num
    character (len=30) :: nom
    integer, dimension(3) :: jma
  end type personne

  ! Variables en argument
  character (len=15), intent(in) :: nom_fichier
  integer, intent(in) :: n_amis
  integer, dimension(3), intent(in) :: date_du_jour
  type(personne), dimension(n_amis), intent(out) :: p

  ! Variables locales
  integer :: l
  logical :: test_annif

  ! Instructions
  ! Ouverture du fichier de la base de donnees
  open(10,file=nom_fichier)
  read(10,*) 
  read(10,*) 
  ! Balayage de la liste des amis
  do l = 1,n_amis   
    read(10,*)p(l)%num,p(l)%nom,p(l)%jma(2),p(l)%jma(1),p(l)%jma(3)
    ! recherche de la correspondance de jour et de mois
    if ( test_annif(p(l)%jma(1),p(l)%jma(2),date_du_jour(1),date_du_jour(2)) .eqv. .true. ) then
      print*,"Aujourd'hui c'est l'anniversaire de ",p(l)%nom, &
             " qui a ",date_du_jour(3)-p(l)%jma(3)," ans"
    end if
  end do
  close (10)

end subroutine qui_annif

!-----------------------------------------
subroutine age_stat(n_amis,date_du_jour,p)

  implicit none
  ! Definition de la structure
  type personne
    integer :: num
    character (len=30) :: nom
    integer, dimension(3) :: jma
  end type personne
  ! Variables en argument
  integer, intent(in) :: n_amis
  integer, dimension(3), intent(in) :: date_du_jour
  type(personne), dimension(n_amis), intent(in) :: p
  ! Variables locales
  integer :: l
  integer, dimension(n_amis) :: age

  ! Instructions
  do l = 1,n_amis
    age(l) =  date_du_jour(3)-p(l)%jma(3)
    if ( p(l)%jma(2)>=date_du_jour(2) .and. p(l)%jma(1)>date_du_jour(1) ) then
      age(l) = age(l) - 1
    end if
  end do
  print*,"La personne la plus jeune a ",minval(age)," ans"
  print*,"La personne la plus agee a ",maxval(age)," ans"
  print*,"L'age moyen est ",sum(age)/max(1,size(age))

end subroutine age_stat







